'--------------------------------------------------------------------------
'File Name:	 MS_Hf_Install.vbs
'Author:	   Jigar Desai
'Purpose:	   To use common MS Hotfixes install file, for both CD and RSD
'Usage:     [CScript | WScript] MS_Hf_Install.vbs Deployment_Type Patch_label LogFileName
'           For Example, CScript MS_Hf_Install.vbs RSD April07_HF  C:\temp\MIApps_6.5.9.12.log 
'                    or  CScript MS_Hf_Install.vbs CD ALL  C:\temp\MIApps_6.5.9.13.log
'--------------------------------------------------------------------------

dim oShell, filesys
dim cmd, return_code, args, num
dim Deployment, Patch_label, LOGName 

set args = WScript.Arguments
num = args.Count

if num = 0 then
   WScript.Echo "Usage: [CScript | WScript] MS_Hf_Install.vbs Deployment_Type Patch_label"
   WScript.Echo "For Example, CScript MS_Hf_Install.vbs RSD ALL C:\temp\MIApps_6.5.9.12.log"
   WScript.Echo "For Example, CScript MS_Hf_Install.vbs CD ALL C:\temp\MIApps_6.5.9.13.log"
   WScript.Quit 1
end if

Deployment = args(0)
Patch_label = args(1)
LOGName = args(2)

Set oShell = CreateObject("WScript.Shell")
Set filesys = CreateObject("Scripting.FileSystemObject")

If filesys.FileExists(LOGName) Then
	Set logfile = filesys.OpenTextFile(LOGName, 8)
else
	Set logfile = filesys.CreateTextFile(LOGName, True)
end if

logfile.WriteLine(vbNewLine)
logfile.WriteLine(vbNewLine)
logfile.WriteLine(Date() & vbTab & Time())

'Install MS hotfixes
'No Check Necessary since this is first setup MS hotfixes included after MI Apps 2007A
if Deployment = "CD" OR (Deployment = "RSD") then
  logfile.WriteLine("Installing MS Hotfixes for April 2007")

	logfile.WriteLine(vbTab & "Installing MS Hotfix KB925902")
	cmd = "MS07-017.WindowsXP-KB925902-x86-ENU.exe /passive /nobackup /norestart"
	return_code = oShell.run(cmd, 1, True)
	logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB925902 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB925902 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB925902")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

	logfile.WriteLine(vbTab & "Installing MS Hotfix KB931261")
	cmd = "MS07-019.WindowsXP-KB931261-x86-ENU.exe /passive /nobackup /norestart"
	return_code = oShell.run(cmd, 1, True)
	logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB931261 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB931261 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB931261")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

	logfile.WriteLine(vbTab & "Installing MS Hotfix KB932168")
	cmd = "MS07-020.WindowsXP-KB932168-x86-ENU.exe /passive /nobackup /norestart"
	return_code = oShell.run(cmd, 1, True)
	logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)	
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB932168 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB932168 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB932168")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

	logfile.WriteLine(vbTab & "Installing MS Hotfix KB930178")
	cmd = "MS07-021.WindowsXP-KB930178-x86-ENU.exe /passive /nobackup /norestart"
	return_code = oShell.run(cmd, 1, True)
	logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB930178 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB930178 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB930178")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

	logfile.WriteLine(vbTab & "Installing MS Hotfix KB931784")
	cmd = "MS07-022.WindowsXP-KB931784-x86-ENU.exe /passive /nobackup /norestart"
	return_code = oShell.run(cmd, 1, True)
	logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB931784 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB931784 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB931784")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

	logfile.WriteLine("Finish installing MS Hotfixes for April 2007")


'Install May 2007 MS hotfixes
'There were no patches for May 2007


  logfile.WriteLine("Installing MS Hotfixes for Jun 2007")

  logfile.WriteLine(vbTab & "Installing MS Hotfix KB935840")
  cmd = "MS07-031.WindowsXP-KB935840-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB935840 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB935840 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS KB935840 KB925902")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

  logfile.WriteLine(vbTab & "Installing MS Hotfix KB929123")  
  cmd = "MS07-034.WindowsXP-KB929123-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB929123 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB929123 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB929123")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

  logfile.WriteLine(vbTab & "Installing MS Hotfix KB935839")
  cmd = "MS07-035.WindowsXP-KB935839-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB935839 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB935839 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB935839")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

  logfile.WriteLine("Finish installing MS Hotfixes for Jun 2007")

  logfile.WriteLine("Installing MS Hotfixes for July 2007")

  logfile.WriteLine(vbTab & "Installing MS Hotfix KB928366")
  logfile.WriteLine(vbTab & vbTab & "Checking existance of MS07-040.NET1.1.SP1.NDP1.1sp1-KB928366")
  If RegRead("HKLM\SOFTWARE\Microsoft\Updates\.NETFramework\1.1" _
         & "\M928366\Installed") <> "1" Then
        cmd = "MS07-040.NET1.1.SP1.NDP1.1sp1-KB928366-X86.exe /I /q"
  	return_code = oShell.run(cmd, 1, True)
        logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB928366 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB928366 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB928366")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select
  else
	logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB928366 is already installed on the system. Setup is skipping installation of KB928366")
  End if

  logfile.WriteLine(vbTab & "Installing MS Hotfix KB939373")
  cmd = "MS07-041.WindowsXP-KB939373-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB939373 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB939373 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB939373")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

  logfile.WriteLine("Finish installing MS Hotfixes for July 2007")

  logfile.WriteLine("Installing MS Hotfixes for August 2007")

 logfile.WriteLine(vbTab & "Installing MS Hotfix KB936181")
  cmd = "MS07-042.msxml4-KB936181-enu.exe /q reboot=reallysupress"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB936181 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB936181 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB936181")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

 logfile.WriteLine(vbTab & "Installing MS Hotfix KB921503")
  cmd = "MS07-043.WindowsXP-KB921503-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB921503 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB921503 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB921503")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

 logfile.WriteLine(vbTab & "Installing MS Hotfix KB937143")
  cmd = "MS07-045.WindowsXP-KB937143-x86-ENU.exe /passive /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB937143 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB937143 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB937143")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select
  
 logfile.WriteLine(vbTab & "Installing MS Hotfix KB938829")
  cmd = "MS07-046.WindowsXP-KB938829-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB938829 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB938829 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB938829")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

 logfile.WriteLine(vbTab & "Installing MS Hotfix KB936782")
  cmd = "MS07-047.WindowsMedia9-KB936782-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB936782 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB936782 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB936782")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

 logfile.WriteLine(vbTab & "Installing MS Hotfix KB938127")
  cmd = "MS07-050.WindowsXP-KB938127-x86-ENU.exe /passive /nobackup /norestart"
  return_code = oShell.run(cmd, 1, True)
  logfile.WriteLine(vbTab & vbTab & "MS Hotfix return code is " & return_code)
	Select case return_code
	Case 0
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB938127 Installed successfully.")
	Case 3010
		logfile.WriteLine(vbTab & vbTab & "MS Hotfix KB938127 Installed successfully and reboot requires.")
	Case Else
		logfile.WriteLine(vbTab & vbTab & "ERROR: Installing MS Hotfix KB938127")
		if  Deployment = "RSD" then
			Wscript.quit("1")
		End if
	end select

  logfile.WriteLine("Finish installing MS Hotfixes for August 2007")
end if

logfile.WriteLine("MS HotFix installation successfully finished on " & Date() & vbTab & Time())

Set oShell = Nothing
Set filesys = Nothing
Set logfile = Nothing
set args = Nothing
Wscript.quit("0")

Function RegRead(ByVal sRegValue)
      Set oShell = CreateObject("WScript.Shell")
      On Error Resume Next
      RegRead = oShell.RegRead(sRegValue)
      logfile.WriteLine(vbTab & vbTab & "Installed Value of " & sRegValue & " is: " & RegRead)
      ' If the value does not exist, error is raised
      If Err Then
        RegRead = ""
        Err.clear
      End If
      ' If a value is present but uninitialized the RegRead method
      ' returns the input value in Win2k.
      If VarType(RegRead) < vbArray Then
        If RegRead = sRegValue Then
          RegRead = ""
        End If
      End If
      On Error Goto 0
End Function
